
/* Ex.3  Lezione 25/02/2010
 *
 *  Scrivere la funzione:
 *         int anagramma(char *s1, char *s2) ;
 *  che restituisca 1 se le stringhe puntate da s1 e s2 sono una
 *  l'anagramma dell'altro e 0 altrimenti.
 *  
 *   Es.:
 *       anagramma(“pizza”,”pazzi”) == 1
 *   
 *  Nota: Assumere che le stringhe siano composte da solo lettere minuscole a-­z, 
 *  aventi codifica intera da 97 a ­122. 
 *  
 *  Hint: Costruire un vettore di frequenze F di 26 posizioni tale che il numero di 
 *  occorrenze del carattere c sia memorizzato in F[c­-97]. Due stringhe sono anagrammi 
 *  se e solo se i due rispettivi vettori di frequenza contengono valori uguali 
 *
 */

#include <stdio.h>

int anagramma(char *s1, char *s2){

int F1[26], F2[26];    /* vettori di frequenze per s1 e s2       */
int i, res;            /* output memorizzato nel valore di res   */

 for (i=0; i<26; i++) 
   F1[i] = F2[i] = 0;  /*  inizializza i due vettori di frequenza */

 for (i=0; s1[i]; i++) 
  F1[s1[i]-97]++;      /*  accumula in F1[c-97] il numero di occorrenze di c in s1 */  

 for (i=0; s2[i]; i++) 
  F2[s2[i]-97]++;      /*  accumula in F2[c-97] il numero di occorrenze di c in s2 */ 


 /*  confronta i valori contenuti in F1 e F2: 
  *     se F1[c] != F2[c] per qualche carattere c setta res=0 
  */ 

 res = 1;
 for (i=0; i< 26 && res; i++)
  if (F1[i] != F2[i]) 
   res = 0;               

 return res;

}

int main(){

char *s1 = "desserts";
char *s2 = "stressed";

printf("%d\n", anagramma(s1,s2));
return 0;

}




